/*
  File name: CCytadelaSave.cpp
  Copyright: (C) 2005 - 2007 Tomasz Kazmierczak

  Creation date: 16.07.2005 01:50
  Last modification date: 22.08.2007

  This file is part of Cytadela

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *

*/

#include "CCytadelaSave.h"
#include <stdio.h>
#include <memory.h>

bool CCytadelaSave::readSaveFile(char *szSysDirPath)
{
	char szSaveFilePath[FILENAME_MAX];
	sprintf(szSaveFilePath, "%s/sav", szSysDirPath);
	FILE *pSaveFile = fopen(szSaveFilePath, "rb");
	if(not pSaveFile)
	{
		fprintf(stderr,"CCytadelaSave::readSaveFile(): !fopen(\"%s\")\n", szSaveFilePath);
		return false;
	}
	if(fread(mSave, 1, sizeof(SaveStruct) * 5, pSaveFile) < sizeof(SaveStruct) * 5)
	{
		fprintf(stderr,"CCytadelaSave::readSaveFile(): !fread(\"%s\")\n", szSaveFilePath);
		return false;
	}
	fclose(pSaveFile);
	return true;
}

bool CCytadelaSave::writeSaveFile(char *szSysDirPath)
{
	char szSaveFilePath[FILENAME_MAX];
	sprintf(szSaveFilePath, "%s/sav", szSysDirPath);
	FILE *pSaveFile = fopen(szSaveFilePath, "wb");
	if(not pSaveFile)
	{
		fprintf(stderr,"CCytadelaSave::writeSaveFile(): !fopen(\"%s\")\n", szSaveFilePath);
		return false;
	}
	if(fwrite(mSave, 1, sizeof(SaveStruct) * 5, pSaveFile) < sizeof(SaveStruct) * 5)
	{
		fprintf(stderr,"CCytadelaSave::writeSaveFile(): !fwrite(\"%s\")\n", szSaveFilePath);
		return false;
	}
	fclose(pSaveFile);
	return true;
}

void CCytadelaSave::reset()
{
	memset(mSave, 0, sizeof(SaveStruct) * 5);
	for(int32_t i = 0; i < 5; ++i)
		mSave[i].eLevel = NO_LEVEL;
}
